﻿namespace IRaCIS.Core.Domain.Models;

[Comment("项目 - 影像下载监控")]
[Table("TrialImageDownload")]
public class TrialImageDownload : BaseFullAuditEntity
{
    #region 导航属性
    [JsonIgnore]
    public Trial Trial { get; set; }

    #endregion

    public Guid TrialId { get; set; }

    public string SubjectCode { get; set; }

    public bool IsSuccess { get; set; }

    public DateTime DownloadStartTime { get; set; }
    public DateTime? DownloadEndTime { get; set; }

    public string VisitName { get; set; }

    public ImageType ImageType { get; set; }

    public int NoneDicomStudyCount { get; set; }

    public int DicomStudyCount { get; set; }

    public int ImageCount { get; set; }
    public long ImageSize { get; set; }

    public string IP { get; set; }

}

public enum ImageType
{
    Dicom = 1,

    NoneDicom = 2,

    DicomAndNoneDicom = 3
};
