using EntityFrameworkCore.Projectables;
using IRaCIS.Core.Domain.Share;

namespace IRaCIS.Core.Domain.Models;

[Comment("̨ - ϵͳ˻")]
[Table("User")]
public class User : BaseFullAuditEntity
{
    #region 

    [ForeignKey("UserTypeId")]
    public UserType UserTypeRole { get; set; }

    [JsonIgnore]
    public List<SystemDocConfirmedUser> SystemDocConfirmedList { get; set; }

    [JsonIgnore]
    public List<TrialUser> UserTrials { get; set; } = new List<TrialUser>();

    [JsonIgnore]
    public List<VisitTask> VisitTaskList { get; set; }

    [Projectable]
    public string FullName => LastName + " / " + FirstName;

    #endregion

    [Comment("Զлһ")]
    public bool AutoCutNextTask { get; set; }

    public int Code { get; set; }

    [StringLength(400)]
    public string DepartmentName { get; set; } = null!;

    [Comment("ҽ˺ź󣬻ֵ")]
    public Guid? DoctorId { get; set; }

    public string EMail { get; set; } = null!;

    [StringLength(1020)]
    public string EmailToken { get; set; } = null!;

    public string FirstName { get; set; } = null!;

    [Comment("״ε¼Ҫ޸")]
    public bool IsFirstAdd { get; set; } = true;

    public bool IsTestUser { get; set; }

    [Comment("ڲû  ⲿû")]
    public bool IsZhiZhun { get; set; }

    [Comment("һ޸ʱ")]
    public DateTime? LastChangePassWordTime { get; set; }

    public string LastLoginIP { get; set; } = null!;

    public DateTime? LastLoginTime { get; set; }

    [StringLength(510)]
    public string LastName { get; set; } = null!;

    public string OrganizationName { get; set; } = null!;

    public string Password { get; set; } = null!;

    public bool PasswordChanged { get; set; }

    [StringLength(400)]
    public string Phone { get; set; } = null!;

    [StringLength(400)]
    public string PositionName { get; set; } = null!;

    public int? Sex { get; set; }

    public UserStateEnum Status { get; set; } = UserStateEnum.Enable;

    public bool SuperAdmin { get; set; }

    [StringLength(400)]
    public string UserCode { get; set; } = null!;

    public string UserName { get; set; } = null!;

    public UserTypeEnum UserTypeEnum { get; set; }

    public Guid UserTypeId { get; set; }
}
